/*
 *
 * AttributeCommands
 *
 * This class handles all the possible in-game commands for the attribute system
 *
 *
*/

package jesse.keeblarcraft.Commands;

import com.mojang.brigadier.arguments.StringArgumentType;
import com.mojang.brigadier.context.CommandContext;

import net.fabricmc.fabric.api.command.v2.CommandRegistrationCallback;
import net.minecraft.command.argument.EntityArgumentType;
import net.minecraft.server.command.CommandManager;
import net.minecraft.server.command.ServerCommandSource;
import net.minecraft.server.network.ServerPlayerEntity;

public class AttributeCommands {
    public void RegisterCommands() {

        // Command Root: "/attributes apply <username> <attribute name>"
        CommandRegistrationCallback.EVENT.register((dispatcher, registryAccess, environment) -> {
            dispatcher.register(CommandManager.literal("attributes")
            .then(CommandManager.literal("apply")
            .then(CommandManager.argument("username", EntityArgumentType.player()))
            .then(CommandManager.argument("attributeName", StringArgumentType.string()))
            .executes(context -> ApplyAttribute(
                                                EntityArgumentType.getPlayer(context, "username"),
                                                StringArgumentType.getString(context, "attributeName"),
                                                context
                                                ))));
        });

        // Command Root: "/attributes remove <username> <attribute name>"
        CommandRegistrationCallback.EVENT.register((dispatcher, registryAccess, environment) -> {
            dispatcher.register(CommandManager.literal("attributes")
            .then(CommandManager.literal("delete")
            .then(CommandManager.argument("username", EntityArgumentType.player()))
            .then(CommandManager.argument("attributeName", StringArgumentType.string()))
            .executes(context -> DeleteAttribute(
                EntityArgumentType.getPlayer(context, "username"),
                                                StringArgumentType.getString(context, "attributeName"),
                                                context
                                                ))));
        });
    }

    public int ApplyAttribute(ServerPlayerEntity targetPlayer, String attributeName, CommandContext<ServerCommandSource> context) {
        int ret = -1;

        // if (context.getSource().isExecutedByPlayer()) {
        //     ServerPlayerEntity targetPlayer = context.getSource().getPlayerNames();

        //     if (context.getSource().getpla)
        // }

        return ret;
    }

    public int DeleteAttribute(ServerPlayerEntity username, String attributeName, CommandContext<ServerCommandSource> context) {
        int ret = -1;



        return ret;
    }
}
